Attribute VB_Name = "modGlobals"
Option Explicit

Public Type tagInitCommonControlsEx
   lngSize As Long
   lngICC As Long
End Type
Public Declare Function InitCommonControlsEx Lib "comctl32.dll" (iccex As tagInitCommonControlsEx) As Boolean
Public Const ICC_USEREX_CLASSES = &H200

Public Sub Main()
   On Error Resume Next
   ' this will fail if Comctl not available
   '  - unlikely now though!
   Dim iccex As tagInitCommonControlsEx
   With iccex
       .lngSize = LenB(iccex)
       .lngICC = ICC_USEREX_CLASSES
   End With
   InitCommonControlsEx iccex
   
   ' now start the application
   On Error GoTo 0
   frmLoadROM.Show
End Sub

Public Function ReadIniValue(INIpath As String, KEY As String, Variable As String) As String
  'This code isn't by me.. meh. I just found it in a Google search.
  Dim NF As Integer
  Dim Temp As String
  Dim LcaseTemp As String
  Dim ReadyToRead As Boolean
    
  NF = FreeFile
  ReadIniValue = ""
  KEY = "[" & LCase$(KEY) & "]"
  Variable = LCase$(Variable)
    
  Open INIpath For Binary As NF
  Close NF
  SetAttr INIpath, vbArchive
    
  Open INIpath For Input As NF
  While Not EOF(NF)
    Line Input #NF, Temp
    LcaseTemp = LCase$(Temp)
    If Left(LcaseTemp, 1) = ";" Then GoTo SkipThisLine
    If InStr(LcaseTemp, "[") <> 0 Then ReadyToRead = False
    If LcaseTemp = KEY Then ReadyToRead = True
    If InStr(LcaseTemp, "[") = 0 And ReadyToRead = True Then
      If InStr(LcaseTemp, Variable & "=") = 1 Then
        ReadIniValue = Mid$(Temp, 1 + Len(Variable & "="))
        Close NF: Exit Function
      End If
    End If
SkipThisLine:
  Wend
  Close NF
  ReadIniValue = "ERROR"
End Function

Public Sub ExitProgram()
  'Only use while a level is being edited
  If frmLevelEdit.HasModified Then
    Select Case MsgBox("Your level contains unsaved changes." _
           & vbCrLf & "Would you like to save them before exiting NSMB Editor? :)" _
           , vbYesNoCancel Or vbExclamation Or vbDefaultButton1, App.Title)
      Case vbYes
        SaveLevel
      Case vbCancel
        Exit Sub
    End Select
  End If
  
  End
End Sub

Public Function Str_To_UInt32(Src As String) As Double
  'Thanks to GuyPerfect for this code.
  Dim B(0 To 3) As Byte 'A handy byte array
  Dim i As Integer 'Only used in the For loop
  Dim Ret As Double 'Return value. Not required, but good practice

  'Error handler. Prevents bad data. VB will return 0
  If Len(Src) <> 4 Then Exit Function

  'Fill the Byte array with the values of the string's characters
  For i = 0 To 3
    B(i) = Asc(Mid(Src, i + 1, 1)) 'Getting the "I'th" character
  Next

  'Set the return value. Each Byte is converted to Double to
  'avoid VB's annoying overflow issue. Without CDbl(), this
  'function will fail for any number above 255.
  Ret = CDbl(B(3)) * &H1000000 + CDbl(B(2)) * &H10000 + _
        CDbl(B(1)) * &H100 + B(0)

  'Return the value
  Str_To_UInt32 = Ret
End Function

Public Function StrToInt2B(Src As String) As Long
  StrToInt2B = (256 * CLng(Asc(Mid(Src, 2, 1)))) + CLng(Asc(Mid(Src, 1, 1)))
End Function

Public Function Int2BToStr(ByVal Src As Long) As String
  Int2BToStr = Chr(Src Mod 256) & Chr((Src - (Src Mod 256)) / 256)
End Function
