Attribute VB_Name = "modNitroROM"
Option Explicit

Type ntrHeader
  NamesOffset As Long
  NamesSize As Long
  FATOffset As Long
  FATSize As Long
End Type

Type ntrFile
  Contents() As Byte
  Name As String
  Start As Long
  End As Long
  ParentDir As Long
End Type

Type ntrDirectory
  EntryFileID As Long
  Name As String
  Offset As Long
  ParentDir As Long
End Type

Public ntrFiles() As ntrFile
Public ntrDirectories() As ntrDirectory
Public ntrHeaderData As ntrHeader
Public ntrQuickFindFile As Dictionary
Public hnd As Integer
Public ROMWasFound As Boolean
Public ROMPath As String

Public Sub Load_ROM(ROMName As String)
  Dim CurrentDir As Integer, CurrentFile As Integer, CurrentFileIsIn As Integer
  Dim DirCount As Integer
  Dim TempRead As String

  'Clear out old data.
  Erase ntrFiles
  Erase ntrDirectories
  If ntrQuickFindFile Is Nothing Then Set ntrQuickFindFile = New Dictionary
  ntrQuickFindFile.RemoveAll
  
  'Does the ROM exist?
  If Dir(ROMName) <> "" Then
    ROMWasFound = True
  Else
    ROMWasFound = False
    Exit Sub
  End If

  ROMPath = ROMName
  
  hnd = FreeFile
  Open ROMName For Binary Access Read As #hnd
    'Let's read the header data in.
    Seek #hnd, 65
    ntrHeaderData.NamesOffset = Str_To_UInt32(Input(4, #hnd))
    ntrHeaderData.NamesSize = Str_To_UInt32(Input(4, #hnd))
    ntrHeaderData.FATOffset = Str_To_UInt32(Input(4, #hnd))
    ntrHeaderData.FATSize = Str_To_UInt32(Input(4, #hnd))
    
    'Read the directory table..
    Seek #hnd, ntrHeaderData.NamesOffset + 1
    DirCount = -1 'Hackish way to check if it's the first dir
    Do
      'Get data about the directory
      ReDim Preserve ntrDirectories(CurrentDir)
      ntrDirectories(CurrentDir).Offset = Str_To_UInt32(Input(4, #hnd))
      ntrDirectories(CurrentDir).EntryFileID = StrToInt2B(Input(2, #hnd))
      ntrDirectories(CurrentDir).ParentDir = StrToInt2B(Input(2, #hnd))
      
      'Is it the parent directory? If so, get the DirCount
      If DirCount = -1 Then DirCount = ntrDirectories(CurrentDir).ParentDir
      CurrentDir = CurrentDir + 1
    Loop Until CurrentDir = DirCount
    
    'Read the file table, now
    CurrentDir = 1
    Do
      TempRead = " "
      Get #hnd, , TempRead
      'TempRead = Input(1, #hnd)
      If Asc(TempRead) > 128 Then
        'It's a directory
        TempRead = Chr(Asc(TempRead) - 128)
        TempRead = String(Asc(TempRead), " ")
        Get #hnd, , TempRead
        ntrDirectories(CurrentDir).Name = TempRead
        CurrentDir = CurrentDir + 1
        TempRead = Input(2, #hnd)
      Else
        'It's a file
        ReDim Preserve ntrFiles(CurrentFile)
        TempRead = String(Asc(TempRead), " ")
        Get #hnd, , TempRead
        If TempRead <> "" Then
          ntrFiles(CurrentFile).Name = TempRead
          ntrFiles(CurrentFile).ParentDir = CurrentFileIsIn
          ntrQuickFindFile(TempRead) = CurrentFile
          CurrentFile = CurrentFile + 1
        Else
          CurrentFileIsIn = CurrentFileIsIn + 1
          If CurrentFileIsIn = DirCount - 1 Then Exit Do
          If CurrentFile < ntrDirectories(CurrentFileIsIn).EntryFileID + 1 Then
            CurrentFile = ntrDirectories(CurrentFileIsIn).EntryFileID + 1
          End If
        End If
      End If
    Loop
    
    'And finally, read the file table
    Seek #hnd, ntrHeaderData.FATOffset + 1
    For CurrentFile = 1 To UBound(ntrFiles)
      TempRead = Input(4, #hnd)
      If TempRead = Chr(255) & Chr(255) & Chr(255) & Chr(255) Then Exit For
      ntrFiles(CurrentFile).Start = Str_To_UInt32(TempRead)
      TempRead = Input(4, #hnd)
      ntrFiles(CurrentFile).End = Str_To_UInt32(TempRead)
    Next CurrentFile
    
    'But don't forget to read the file contents
    For CurrentFile = LBound(ntrFiles) To UBound(ntrFiles)
      If ntrFiles(CurrentFile).Name <> "" And ntrFiles(CurrentFile).End <> 0 Then
        Seek #hnd, ntrFiles(CurrentFile).Start + 1
        ReDim ntrFiles(CurrentFile).Contents(ntrFiles(CurrentFile).End - ntrFiles(CurrentFile).Start - 1)
        Get #hnd, , ntrFiles(CurrentFile).Contents
      End If
    Next CurrentFile
  Close #hnd
End Sub
